<?php
#---- filtres mot-croisés ----------#
#Filtre : grille de mot croisés		#
#Auteur : Maïeul Rouquette,2006		#
#Licence : GPL				   		#
#Contact : maieulrouuquette@tele2.fr#

function lettre($texte) //return la lettre correpondant au chiffres
{$alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
 return $alphabet[$texte-1];}


function calcul_tableau_grille($texte){// cree un tableau qui va contenir la valeau de l'ensemble des cellules.
    
    

    $a_supprimer=array(" class=\"row_even\"",
    	' class="row_odd"',
    	" class=\"row_even\"",
    	"</tr>",
    	"</td>",
		'</tbody>.*',
		"\n"); 
	//liste des elements à supprimer afin de n'avoir plus que de <tr> et <td> dans le corps du texte + elemnt 
	
	foreach ($a_supprimer as $a){
        
       	$texte = eregi_replace($a,'',$texte);
                                        
                                    }
    
    
    
    
    $tableau =explode('<tr>',$texte); //on va scinder la grille en ligne puis mettre cela dans un tableau
    array_shift($tableau); //suprression de ce qu'il y avant la grille
    
    foreach ($tableau as $id =>$ligne){// on va scinder chaque ligne du tableau (qui correspondent Ã  une ligne chacune) en un tableau contenant chaque cellule de la ligne
        
        $tableau[$id] = explode('<td>',$ligne);
        array_shift($tableau[$id]);   // suppresion de ce qu'il y avant la ligne                                 
                                    }
    return $tableau;
    }
              
function solution_grille($tableau_grille){//cree une grille affichant la solution
    
	$hauteur =sizeof($tableau_grille);
    $largeur= sizeof($tableau_grille[0]);
    
    $grille="<table class=\"grille\" summary=\"grille de mots crois&eacute;s de ".$largeur." colonnes sur ".$hauteur." lignes\">\n\t<tr>\n\t\t<td class=\"coin\"></td>\n";
    
    $increment_largeur=1;   //un icnrement pour les cellues d'entete
    
   
    while ($increment_largeur<=$largeur){
        $grille=$grille."\t\t<th scope=\"col\">".$increment_largeur."</th>\n";
        $increment_largeur++;}
    
    $grille=$grille."\t</tr>\n";
    
        
    
    // création des lignes
    foreach($tableau_grille as $ligne =>$contenu_ligne){
        $ligne=$ligne+1;
        $grille=$grille."\t<tr>\n\t\t<th scope=\"row\">".lettre($ligne)."</th>\n";//entête de ligne
        
        foreach ($contenu_ligne as $cellule){
            if ($cellule=="*"){
                    $grille=$grille."\t\t<td class=\"noir\">*</td>\n";
                }
            else{$grille=$grille."\t\t<td>".$cellule."</td>\n";}
                            }
        }
        $grille=$grille."\t</tr>\n";
        
    $grille=$grille."</table>\n";
    return $grille;
    }  
function grille_formulaire($tableau_grille,$page){
    $hauteur =sizeof($tableau_grille);
    $largeur= sizeof($tableau_grille[0]);
  	
    $grille="<form action=\"".$page."\" method=\"post\">\n"; // début formulaire
    
   	$grille=$grille."<table class=\"grille\" summary=\"grille de mots-crois&eacute;s de ".$largeur." colonnes sur ".$hauteur." lignes\">\n\t<tr>\n\t\t<td class=\"coin\"></td>\n";// debut tableau + 1ere celule
    $increment_largeur=1;   //un iccrément pour les cellules d'entete
    while ($increment_largeur<=$largeur){
        $grille=$grille."\t\t<th scope=\"col\">".$increment_largeur."</th>\n";
        $increment_largeur++;}
    
    $grille=$grille."\t</tr>\n";
    
    foreach($tableau_grille as $ligne =>$contenu_ligne){
        $ligne++;
        $grille=$grille."\t<tr>\n\t<th scope=\"row\">".lettre($ligne)."</th>\n";//numeros de ligne
        
        foreach ($contenu_ligne as $colonne =>$cellule){
            $colonne++;
            //s'il s'agit d'un noir
            if ($cellule=="*"){
                    $grille=$grille."\t\t<td class=\"noir\">*</td>\n";
                                }
            else {  $grille=$grille."\t\t<td>";
            		
            		$grille=$grille.'<label for="col'.$colonne.'lig'.$ligne.'">ligne '.lettre($ligne).';colonne '.$colonne.'</label>';
                    
                    if (isset($GLOBALS['col'.$colonne.'lig'.$ligne])) //: test l'existence de la variable global correpsonte à cette cellule
                        {
                        
                        $grille=$grille.'<input type="text" maxlength="1" value="'.$GLOBALS['col'.$colonne.'lig'.$ligne].'" name="col'.$colonne.'lig'.$ligne.'" id="col'.$colonne.'lig'.$ligne."\" /></td>\n";
                        }
                    else
                        {
                        
                        $grille=$grille.'<input type="text" maxlength="1"  name="col'.$colonne.'lig'.$ligne.'" id="col'.$colonne.'lig'.$ligne."\" /></td>\n";                        
						}
            
				}
		}
                                                    
        $grille=$grille."\t</tr>\n";}
        
    
    $grille=$grille."</table>\n";
    $grille=$grille."<br /><input id=\"solution\" name=\"solution[]\" type=\"checkbox\"value=\"1\" /><label for=\"solution\" >Afficher la solution (en bas de la page)</label><br />\n
<input type=\"submit\" value=\"V&eacute;rifier\" name=\"bouton_envoi\" /></form>\n";

    return  $grille;}
    
function comparaison($tableau_grille){// compare les variables Post avec la valeau de la solution...
    $erreurs=0;
    foreach($tableau_grille as $ligne =>$contenu_ligne){
        $ligne++;
        foreach ($contenu_ligne as $colonne =>$cellule){
            $colonne++;
            
            if (strtoupper($GLOBALS["col".$colonne."lig".$ligne])!=strtoupper($cellule) and $cellule!='*') //compare les valeurs du tableau PHP avec les variables POST
               {$erreurs++;
               
         		}
         	
               
            }
            }
    return $erreurs;}
    

function grille($texte,$page){
	if (eregi("<grille>",$texte)!=1){return $texte;} //verifie s'il y a une grille de mot croisé
    
    $tableau_grille=calcul_tableau_grille($texte);
    
    
    
   
    
	$grille_formulaire=grille_formulaire($tableau_grille,$page);
    
    $erreur=comparaison($tableau_grille); 
    if ($erreur==0){$erreur='<strong class="erreur">'.Aucune.' erreur</strong> ';}
    if ($erreur>=2){$erreur='<strong class="erreur">'.$erreur." erreurs</strong> ";}
    if ($erreur==1){$erreur='<strong class="erreur">'.Une.' erreur</strong> ';};
   
    echo $bouton_envoi;
    if 	($GLOBALS["bouton_envoi"] == ''){$erreur='';}
                              
	$texte=eregi_replace('<p class="spip"><grille></p>.*</grille></p>',$erreur.$grille_formulaire,$texte);
    // les defs verticals
    $texte=eregi_replace('<p class="spip"><vertical></p>','<div class="spip vertical"><h4 class="spip grille">Verticalement :</h4>',$texte);
   	$texte=eregi_replace("</vertical></li></ol>",'</li></ol></div>',$texte);
    
    // les definitions horizontal
    $texte=eregi_replace('<horizontal></p>','<div class="spip horizontal"><h4 class="spip grille">Horizontalement :</h4>',$texte);
    $texte=eregi_replace("</horizontal></li></ol>",'</li></ol></div>',$texte);
   
   	if ($GLOBALS["solution"][0] == 1){$texte = $texte."<div class=\"solution\"><h2 class=\"spip\">Solution : </h2>".solution_grille($tableau_grille)."</div>";}
     
    
    return $texte;
    } 
#--- fin filtre mot-croisés ---#

?>